IR.AddListener(IR.EVENT_START, 0, function () {
   var Module = {};
	var Device = IR.GetDevice("Z-Wave");
   // var st_list = IR.GetItem("Page 1").GetItem("Item 1");
   IR.GetItem("Page 1").GetItem("Item 1").Type = 3;   
   IR.GetItem("Page 2").GetItem("Item 1").Type = 3;
   for (var i = 0; i < dataSetup.m_data.length; i++) {
   var type = dataSetup.m_data[i].TYPE;//IR.GetVariable("Tokens.DevType" + Module.ID);
   var DeviceID = dataSetup.m_data[i].DEVICE_ID;
   var st_list = dataSetup.m_data[i].ST_LIST;
   IR.Log("klog                 " + type + "             " + DeviceID);
   IR.SetVariable("Tokens.DevType", type)
   var moduleBody = [];
	var modulePopup = [];
   var prevStatus;
	Module.isCanUpdateInerface = true;
   //IR.SetVariable("Tokens.DevType", type)
   //["temperature", "door", "window", "flood", "smoke", "motion", "thermostat", "setpoint", "binaryswitch", "light", "multilevelswitch", "rgb"];
   switch (type){
      case "motion":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);  
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("MotionSensor");            
         break;
      case "temperature":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("Temperature");
         break;
      case "door":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("DoorSensor");
         break;
      case "window":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("WindowSensor");
         break;
      case "flood":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("WindowSensor");
         IR.ShowPopup("FloodSensor");
         break;
      case "smoke":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("SmokeSensor");
         break;
      case "thermostat":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("Thermostat");
         break;
      case "setpoint":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("Thermostat");
         break;
      case "binaryswitch":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("BinarySwitch");
         break;
      case "multilevelswitch":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("MultilevelSwitch");
         break;
      case "light":
         InitModulesPopup();
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("MultilevelSwitch");
         break;   
      case "rgb":
         
         InitModulesBody(type, DeviceID);
         IR.GetItem(st_list).GetItem("Item 1").AddPopup("SwitchRGB");
         InitModulesPopup();
         break;
   }
	if (typeof ___FibaroDevice == 'undefined') {
		___FibaroDevice = new FibaroClass(Device);
		___FibaroDevice.Init();

	}
	if (___FibaroDevice) {
		//Module.callbackAfterGetType = afterGetType;
		Module.callbackStatusChanged = function (currentStatus) {
			// subevice is online

			if (currentStatus && currentStatus != prevStatus) {
				IR.Log("online t= " + IR.GetVariable("Tokens.DevType"));
				var popup = modulePopup[IR.GetVariable("Tokens.DevType")];
				if (popup && popup.GetItem("Offline"))
					popup.GetItem("Offline").Visible = false;
			}
			// subevice is offline
			if (!currentStatus && currentStatus != prevStatus) {
				var popup = modulePopup[IR.GetVariable("Tokens.DevType")];
				if (popup && !popup.GetItem("Offline")) {
					var offlinePopUp = popup.CreateItem(IR.ITEM_BUTTON, "Offline", 0, 0, popup.Width, popup.Height);
					offlinePopUp.GetState(0).Color = (0xFF << 24) | (0xFF << 16) | (0xFF << 8) | 0xFF;
					offlinePopUp.GetState(0).Opacity = 190;
					offlinePopUp.GetState(0).Text = "Device is offline";
					offlinePopUp.GetState(0).TextColor = (255 << 24) | (0 << 16) | (0 << 8) | 0xFF;
					IR.CreateFont(12479, "helveticaneuecyr-roman.ttf", 20);
					offlinePopUp.GetState(0).FontId = 12479;

					IR.Log("offline");
				} else
					offlinePopUp.Visible = true;

			}

			prevStatus = currentStatus;
		};

		___FibaroDevice.AddModule(Module);

	}
	//  если тип уже определен вызываем тело модуля
	if (type && moduleBody[type]instanceof Function) {
		moduleBody[type](); // вызывается функция соответствующая текущему типу устройства
	}

	/*function afterGetType(Module, deviceType) // сработает только если тип еще не определен
	{
		IR.Log("~~~~~~~~~~~~~~ makeWidget ");
		//  вызываем тело модуля
		if (deviceType && moduleBody[deviceType]instanceof Function) {
			moduleBody[deviceType]();
		}

		//  добавление виджета взависимости от типа
		var Widgets = SubDevice.getWidgets();

		if (0 == Widgets.length) {
			var popup = IR.GetItem("UnknownType" + Module.ID);
			if (modulePopup[deviceType])
				popup = modulePopup[deviceType];
			var widget = SubDevice.addWidget(popup);
         deviceType = deviceType == "" ? "unknown type" : deviceType;
			Module.getVirtualTag("DevType" + Module.ID).Value = deviceType;
			IR.SetVariable("Tokens.DevType" + Module.ID, deviceType);

		}
	} */
   };
// модули
	function InitModulesBody(in_type, in_DeviceID) {

		if (in_type == 'multilevelswitch' || in_type == 'light'){
         moduleBody[in_type] = function () {
   
   			IR.Log("~~~~~~~~~~~~~~~ MultilevelSwitch body");
   
   			var UserSlider_1 = new SliderF(IR.GetItem("MultilevelSwitch").GetItem("Level"), IR.GetItem("MultilevelSwitch").GetItem("Slider1"));
   			IR.AddListener(IR.EVENT_CHANNEL_SET, Device, function (name, _value) {
   				var value = String(_value)
   					var command = "";
   				var feedbackName = "Feedback1";
   				if (value == "switcher") {
   					command = "&name=" + (IR.GetPopup("MultilevelSwitch").GetItem("switcher").Value ? "turnOff" : "turnOn");
   					feedbackName = "Feedback2";
   					value = IR.GetPopup("MultilevelSwitch").GetItem("switcher").Value;
   				} else
   					command = "&name=setValue&arg1=" + value;
   
   				//IR.Log("GET,/api/callAction?deviceID="+Module["Device ID"] +command );
   				___FibaroDevice.device.Send(["GET,/api/callAction?deviceID=" + in_DeviceID + command]);
   
   				Device.SetFeedback(feedbackName, value);
   				Module.isCanUpdateInerface = false;
   			});
   
   		};
      }
      
      if (in_type == 'rgb'){
   		moduleBody[in_type] = function () { // rgb switcher
            
   			IR.Log("~~~~~~~~~~~~~~~ rgb body");
   
   			IR.AddListener(IR.EVENT_CHANNEL_SET, Device, function (name, _value) {
   				var value = String(_value);
   				var command = "";
   				var feedbackName = "Feedback1";
   				if ("turnOn" == value || "turnOff" == value) {
   					command = "&name=" + value;
   					feedbackName = "Feedback2";
   					value = value == "turnOn" ? 0 : 1;
   				} else if (value.indexOf("switcher") != -1) {
   					command = "&name=" + (IR.GetPopup("SwitchRGB").GetItem("trigger_button").Value ? "turnOff" : "turnOn");
   					feedbackName = "Feedback2";
   					value = IR.GetPopup("SwitchRGB").GetItem("trigger_button").Value;
   				} else {
   					var color = parseInt(value);
   					if (color < 0) {
   						color += 0xFFFFFFFF
   					}
   					red = (color >> 24) & 0xFF;
   					green = (color >> 16) & 0xFF;
   					blue = (color >> 8) & 0xFF;
   					IR.Log("Set color R=" + red + " G=" + green + " B=" + blue);
   					command = "&name=setColor&arg1=" + red + "&arg2=" + green + "&arg3=" + blue + "&arg4=0";
   
   				}
   
   				//IR.Log("GET,/api/callAction?deviceID="+Module["Device ID"] +command );
   				___FibaroDevice.device.Send(["GET,/api/callAction?deviceID=" + in_DeviceID + command]);
   
   				Device.SetFeedback(feedbackName, value);
   				Module.isCanUpdateInerface = false;
   			});
   
   		};
      }
      
      if (in_type == 'binaryswitch'){
   		moduleBody[in_type] = function () {
   			IR.Log("~~~~~~~~~~~~~~~ binarySwitch body");
   
   			IR.AddListener(IR.EVENT_CHANNEL_SET, Device, function (name, _value) {
   
   				var value = String(_value)
   
   					var command = "";
   				var feedbackName = "Feedback1";
   				if (value == "switcher") {
   					command = "&name=" + (IR.GetPopup("BinarySwitch").GetItem("trigger_button").Value ? "turnOff" : "turnOn");
   					value = IR.GetPopup("BinarySwitch").GetItem("trigger_button").Value;
   				} else if ("turnOn" == value || "turnOff" == value) {
   					command = "&name=" + value;
   					value = ("turnOn"== value ? 0 : 1);
   				}
   
   				//IR.Log("GET,/api/callAction?deviceID="+Module["Device ID"] +command );
   				___FibaroDevice.device.Send(["GET,/api/callAction?deviceID=" + in_DeviceID + command]);
   
   				Device.SetFeedback(feedbackName, value);
   				Module.isCanUpdateInerface = false;
   			});
   
   		};
      }
      
      if (in_type == 'thermostat' || in_type == 'setpoint'){
   		moduleBody[in_type] = function () { //  термостат
   			IR.Log("~~~~~~~~~~~~~~~ setpoint body");
            
   
   				var popup = IR.GetPopup("ThermostatRemote");
   				var up = popup.GetItem("up plus 88x64");
   				var down = popup.GetItem("down minus 88x64");
   				var max = popup.GetItem("max");
   				var min = popup.GetItem("min");
   				var displayValue = popup.GetItem("value 120x88 1");
               
   			
   				/*var popup = IR.GetPopup("ThermostatRemotePhone");
   				var up = popup.GetItem("up plus 88x64");
   				var down = popup.GetItem("down minus 88x64");
   				var max = popup.GetItem("max");
   				var min = popup.GetItem("min");
   				var displayValue = popup.GetItem("value 120x88 1"); */
               

            popup.GetState(0).FillColor = 0x00000066;
   			//status  переменная, с которой будет сравниваться текущее значение температуры
   			var status;
            
   			//displayValue1 вывод температуры на виджете
   			var displayValue_1 = modulePopup['setpoint'].GetItem("value 120x88");
   			var changeBut = modulePopup['setpoint'].GetItem("ChangeThermo");
   
   			//переменная step испол. для увеличения или уменьшения значения температуры
   			var step = 1;
   
   			//функция Max используется для задания максимальной температуры
   			function Max() {
   				displayValue.Value = 40;
   				status = displayValue.Value;
   			}
   			//функция Min используется для задания минимальной температуры
   			function Min() {
   
   				displayValue.Value = 5;
   				status = displayValue.Value;
   			}
   			//функция Up используется для увеличения температуры
   			function Up() {
   
   				displayValue.Value += step;
   				if (displayValue.Value >= 40) {
   					displayValue.Value = 40;
   				}
   				status = displayValue.Value;
   			}
   			//функция Down используется для уменьшения температуры
   			function Down() {
   
   				displayValue.Value -= step;
   				if (displayValue.Value <= 5) {
   					displayValue.Value = 5;
   				}
   				status = displayValue.Value;
   			}
   
   			//подписка на события
   			IR.AddListener(IR.EVENT_ITEM_PRESS, up, Up);
   			IR.AddListener(IR.EVENT_ITEM_PRESS, down, Down);
   			IR.AddListener(IR.EVENT_ITEM_HOLD, up, Up);
   			IR.AddListener(IR.EVENT_ITEM_HOLD, down, Down);
   			IR.AddListener(IR.EVENT_ITEM_RELEASE, max, Max);
   			IR.AddListener(IR.EVENT_ITEM_RELEASE, min, Min);
   			IR.AddListener(IR.EVENT_ITEM_RELEASE, changeBut, function () {
   				displayValue.Value = displayValue_1.Value;
   				IR.ShowPopup(popup.Name)
   			});
   
   			IR.AddListener(IR.EVENT_CHANNEL_SET, Device, function (name, _value) {
   				var value = String(_value);
   				var command = "&name=setTargetLevel&arg1=" + value; //  если пришло значение из экшена
   
   				//если пришло значение value с попапа,
   				if (value.indexOf("value") > -1) {
               
   					command = "&name=setTargetLevel&arg1=" + status;
   				}
   				IR.Log("GET,/api/callAction?deviceID=" + in_DeviceID + command);
   				___FibaroDevice.device.Send(["GET,/api/callAction?deviceID=" + in_DeviceID + command]);
   				Device.SetFeedback("Feedback1", status);
               IR.Log("status " + status)
   				Module.isCanUpdateInerface = false;
   			});
   
   		}
      }
      
      if (in_type == 'window' || in_type == 'flood' || in_type == 'smoke' || in_type == 'motion' || in_type == 'door'){		
   		moduleBody[in_type] = function () {
   			IR.Log("~~~~~~~~~~~~~~~ temperature body"); 
   		}
	   }
   };   

	// виджеты
   	function InitModulesPopup() {
   		IR.Log("~~~~~~~~~~~~~~ InitModulesPopup ");
   		modulePopup['multilevelswitch'] = modulePopup['light'] = IR.GetPopup("MultilevelSwitch");
   		modulePopup['rgb'] = IR.GetPopup("SwitchRGB");
   		modulePopup['binaryswitch'] = IR.GetPopup("BinarySwitch");
   		modulePopup['thermostat'] = modulePopup['setpoint'] = IR.GetPopup("Thermostat");
   		modulePopup['temperature'] =  IR.GetPopup("Temperature");
   		modulePopup['window'] = IR.GetPopup("WindowSensor"); 
   		modulePopup['flood'] = IR.GetPopup("FloodSensor"); 
   		modulePopup['smoke'] = IR.GetPopup("SmokeSensor"); 
   		modulePopup['motion'] = IR.GetPopup("MotionSensor"); 
   		modulePopup['door'] = IR.GetPopup("DoorSensor"); 
      }
});